#!/usr/bin/perl
 
########################################################################
# COPYRIGHT NOTICE:
#
# Copyright 2008 FocalMedia.Net All Rights Reserved.
#
# Selling the code for this program without prior written consent 
# from FocalMedia.Net is expressly forbidden. You may not 
# redistribute this program in any shape or form.
# 
# This program is distributed "as is" and without warranty of any
# kind, either express or implied. In no event shall the liability 
# of FocalMedia.Net for any damages, losses and/or causes of action 
# exceed the total amount paid by the user for this software.
#
########################################################################

#### EDIT HERE -- FOR WINDOWS/IIS BASED INSTALLATIONS ONLY #######

$config_cgi = "../config.cgi"; ## <-- CHANGE THIS LINE TO THE FULL SERVER PATH TO config.cgi

# THE PATH ON A WINDOWS INSTALLATION WILL LOOK SOMETHING LIKE THIS:
# $config_cgi = "c:/inetpub/webpub/cgi-bin/pseek/config.cgi";

#### DO NOT CHANGE ANYTHING BELOW THIS LINE #################

#use FindBin;
#use lib $FindBin::Bin;
use CGI;
use DBI;
use acs;
use obbuild;
#use CGI::Carp qw(fatalsToBrowser); 
 

&get_setup;
$q = CGI->new;

$default_permissions = 0777; ### PERMISSIONS THAT IS USED FOR TEMPORARY DATA FILES 

$dirs_to_check = 10;

$telnet_ssh_pause = 0;

##################################################################################

if ($q->param('fct') eq "") { &telnet_ssh_clean; exit; }

acs::check_access($username, $password, $q->param('username'), $q->param('password'));

print "Content-type: text/html\n\n";
if ($q->param('fct') eq "web") {&web_build;}
if ($q->param('fct') eq "get_top") {&get_top;}
if ($q->param('fct') eq "webclean") {&webclean;}
if ($q->param('fct') eq "dirmapbuilt") {&dirmapbuilt;}
if ($q->param('fct') eq "delete_dirs") {&delete_dirs;}
if ($q->param('fct') eq "chk") {&debugd;}


####################################################################################

sub telnet_ssh_clean
{

if (lc($ARGV[0]) eq "clean")
	{
	print "\nWARNING: This utility will delete directories with it's\n";
	print "contents that does not match up with the categories in your\n";
	print "database. If your 'html' directory is not a sub directory\n";
	print "inside your 'Public HTML' directory then it can cause serious data loss!\n";
	print "The HTML directory is explained in the PowerSeek SQL\n";
	print "Installation instructions\n\n";
	print "Are you sure you want to continue? (Y/N): ";
	
	$answer1 = <STDIN>;
	$answer1 =~ s/\n//g;
	
	if (lc($answer1) eq "y") 
		{
		&clean_html_dir;
		}
			
	}
	elsif (lc($ARGV[0]) eq "cron")
	{
	&clean_html_dir("CRON");
	}
	elsif (lc($ARGV[0]) eq "")
	{
	print "\nInvalid number of arguments. Please refer to the PowerSeek SQL\n";
	print "documentation for instructions on using this utility.\n\n";
	}

}




sub clean_html_dir
{
my ($cron) = @_;

if ((-e "$data_dir/levels.tmp") > 0) { unlink ("$data_dir/levels.tmp"); }
if ((-e "$data_dir/levels_w.tmp") > 0) { unlink ("$data_dir/levels_w.tmp"); }
if ((-e "$data_dir/ldead.tmp") > 0) { unlink ("$data_dir/ldead.tmp"); }


$dirlist[0] = $web_dir;

foreach $adir (@dirlist)
	{
	@subdirs = &get_dir_contents ($adir);
	$tmp = push(@dirlist, @subdirs);
	}

$alldnr = push(@dirlist);

foreach $adir (@dirlist)
	{
	$alldnr = $alldnr - 1;
	$dsubdirs[$alldnr] = $adir;
	}

$indic = 0;


open (LVF, "> $data_dir/levels.tmp");
	foreach $item (@dsubdirs)
		{
		$item =~ s/$web_dir//gi; 
		
		#if (($item ne "/pop") and ($item ne "/new") and ($item ne "/templates") and ($item !~ "/templates/") and ($item ne "/edt") and ($item !~ "/edt") and ($item ne "/imagefiles") and ($item !~ "/imagefiles"))
		if (($item ne "/pop") and ($item ne "/new") and ($item !~ /^\/templates/) and ($item !~ /^\/edt/) and ($item !~ /^\/imagefiles/))
			{
			print LVF $item . "\n";
			$indic++;
			
			if ($indic == 50) 
					{
					$indic = 0;
					if ($cron ne "CRON"){print "Checking... Please wait..\n";}
					}
			}
		}
close (LVF);
chmod($default_permissions,"$data_dir/levels.tmp");


if ($cron ne "CRON"){print "Directory Map Built... Please Wait... \n\n";}





#######
$check_string = "";
$check_cnt = 0;
open (LVC, "$data_dir/levels.tmp");
	while (defined($line=<LVC>))
		{
		$line =~ s/\n//gi;
		
		if ($check_cnt == 10)
			{
			&checkdirs($check_string);
			
			$check_string = "";
			
			if ($cron ne "CRON"){print "Checking: ...\n$print_string\n";}
			
			$print_string = "";
			$check_cnt = 0;
			sleep($telnet_ssh_pause);
			}
			else
			{
			$check_string = $check_string . $line . "\t";
			$print_string = $print_string . $line . "\n";
			}
		
		$check_cnt++;
		}
close (LVC);




####### CLEAN UP

$ddata = &get_file_contents("$data_dir/ldead.tmp"); 

#######

if ($ddata ne "") 
{

open (LOGF, ">> $data_dir/deadirs.txt");

$today_time = time();
$today_time2 = acs::decode_date($today_time);
print LOGF "\n\nDate: $today_time2\n\n";

@dirs_to_delete = split (/\n/, $ddata);

foreach $ditem (@dirs_to_delete)
{
$ditem = $web_dir . "/" . $ditem;

@build_dirs = &get_total_dirs($ditem);

foreach $direc (@build_dirs)
	{

	if ((-e $direc) and ($direc =~ /^$web_dir/))
	{
	 opendir(DDR,"$direc");
			@bdfiles = readdir(DDR);
			foreach $delfile (@bdfiles)
				{
				if (($delfile ne ".") and ($delfile ne "..") and ((-d "$direc/$delfile") < 1))
					{
					$delstat = unlink ("$direc/$delfile");
					
					if ($delstat < 1)
						{
						if ($cron ne "CRON"){print "\n$direc/$delfile - File Not Deleted " . $! . "\n";}
						}
					}
				}
	closedir (DDR);

   $delstat = rmdir($direc);

			if ($delstat > 0)
					{
					if ($cron ne "CRON"){print "$direc - Directory Deleted\n";}
					print LOGF "$direc - Directory Deleted\n";
					}
					else
					{
					if ($cron ne "CRON"){print "\n$direc - Directory Not Deleted " . $! . "\n\n";}
					print LOGF "\n$direc - Directory Not Deleted " . $! . "\n\n";
					}
	}
	
	}


}

#######

if ((-e "$data_dir/levels.tmp") > 0) { unlink ("$data_dir/levels.tmp"); }
if ((-e "$data_dir/levels_w.tmp") > 0) { unlink ("$data_dir/levels_w.tmp"); }
if ((-e "$data_dir/ldead.tmp") > 0) { unlink ("$data_dir/ldead.tmp"); }

#######

close (LOGF);
chmod($default_permissions,"$data_dir/deadirs.txt");

}


&image_files_not_in_use;



if (($cron ne "CRON") and ($ddata ne ""))
	{
	print "\n\nSome Directories was dead and has been deleted.\n\n";
	print "The Directories that has been deleted has been written to:\n";
	print "$data_dir/deadirs.txt\n";
	exit;
	}
### IF NO DEAD FILES
else 
	{
	if ($cron ne "CRON"){print "\n\nThere are no dead directories...\n\n ";}
	exit; 
	}


}




sub image_files_not_in_use
{

### STANDARD IMAGES WITH LINK LISTINGS

if ($mysql_hostname eq ""){$dsn = "DBI:mysql:$db_name";}else{$dsn = "DBI:mysql:$db_name:$mysql_hostname:$mysql_port";}
$dbh = DBI->connect($dsn, $db_username, $db_password);
if ( !defined $dbh ) {die "Cannot connect to MySQL server: $DBI::errstr\n"; } 

$sql = "SELECT lnkid, image FROM links WHERE ((image != '') AND (image IS NOT NULL))";
$sth = $dbh->prepare($sql);
$sth->execute;
$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror";}
$rows = $sth->rows();

	while ( @row = $sth->fetchrow() )
		{
		push (@image_ids, $row[0] . "." . $row[1]);
		}

$nrc = @image_ids;

if ($nrc > 0)
	{
	 opendir(DDR,"$web_dir/imagefiles");
		@bdfiles = readdir(DDR);
		foreach $delfile (@bdfiles)
			{
			if (($delfile ne ".") and ($delfile ne "..") and ((-d "$web_dir/imagefiles/$delfile") < 1))
				{
					$found_match = "false";
					foreach $i_item (@image_ids)
						{
						if ($delfile eq $i_item) { $found_match = "true"; }
						}
					
					if ($found_match ne "true") { unlink ("$web_dir/imagefiles/$delfile"); }
				}
			}
	 closedir (DDR);
	}




### EXTRA FIELDS IMAGES

$keydata = acs::get_file_contents("$data_dir/keys.dat");
@akeys = split(/\n/, $keydata);
$nrc = 0;

	foreach $kitem (@akeys)
		{
		($keyname, $visible, $size1, $searched1, $description, $na, $imagef, $numberfield) = split (/\t/, $kitem);
		 
		 if ($numberfield eq "Upload")
		 	{	
		 		$db_keyname = $keyname . "_cust";
		 		$extra_upload = "true";
		 		$ext_sql = $ext_sql . " (($db_keyname != '') AND ($db_keyname IS NOT NULL)) OR ";
		 	}
		}


### IF THERE ARE EXTRA UPLOAD FIELDS

if ($extra_upload eq "true")
	{
	$ext_sql = substr($ext_sql, 0, length($ext_sql) - 3);
	$compl_sql = "SELECT lnkid FROM links WHERE $ext_sql";
	
	$sth = $dbh->prepare($compl_sql);
	$sth->execute;
	$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror";}
	$rows = $sth->rows();
	
	while ( @row = $sth->fetchrow() )
		{
		$objname = "C" . $row[0];
		$existing_images{$objname} = "Y";
		}

	
	 opendir(DDR,"$web_dir/imagefiles");
		@bdfiles = readdir(DDR);
		foreach $delfile (@bdfiles)
			{
			if (($delfile ne ".") and ($delfile ne "..") and ((-d "$web_dir/imagefiles/$delfile") > 0))
				{
				$objname = "C" . $delfile;
				if ($existing_images{$objname} ne "Y")
					{
						push(@to_del, $delfile);
					}
				
				}
			}
	 closedir (DDR);	


	### DEL IMAGE DIRECTORIES CONTAINING IMAGES THAT IS NOT IN USE ANYMORE
	
	foreach $item (@to_del)
		{
		opendir(DDR,"$web_dir/imagefiles/$item");
		 my @rfiles = readdir(DDR);
		 	foreach $rf (@rfiles)
		 		{
		 			if (($rf ne ".") and ($rf ne ".."))
					{
					$delstat = unlink ("$web_dir/imagefiles/$item/$rf");
					}
		 		}
		 		
		 	$dstat = rmdir("$web_dir/imagefiles/$item");

		closedir(DDR);
		}


} ### END OF EXTRA FIELD IMAGES


$sth->finish;
$dbh->disconnect;

}





sub delete_dead_dirs
{

print qq[<html>
<head>
<title>PowerSeek</title>
<link href="$web_url/ps.css" rel="stylesheet" type="text/css" /> 
</head>
<body>
<span class="normaltext">
];

$ddata = &get_file_contents("$data_dir/ldead.tmp"); 
@dirs_to_delete = split (/\n/, $ddata);
	

#######	

foreach $ditem (@dirs_to_delete)
{
$ditem = $web_dir . "/" . $ditem;


@build_dirs = &get_total_dirs($ditem);

foreach $direc (@build_dirs)
	{
	#print "=!!=> $direc<BR><BR>";
	
	if ((-e $direc) and ($direc =~ /^$web_dir/))
	{
	 opendir(DDR,"$direc");
			@bdfiles = readdir(DDR);
			foreach $delfile (@bdfiles)
				{
				if (($delfile ne ".") and ($delfile ne "..") and ((-d "$direc/$delfile") < 1))
					{
					$delstat = unlink ("$direc/$delfile");
					
					if ($delstat < 1)
						{
						print "$direc/$delfile - <font color=\"#FF0000\">File Not Deleted</font> " . $! . "<BR><BR>";
						}
					}
				}
	closedir (DDR);

   $delstat = rmdir($direc);

			if ($delstat > 0)
					{
					print "$direc - Directory Deleted<BR><BR>";
					}
					else
					{
					print "$direc - <font color=\"#FF0000\">Directory Not Deleted</font> " . $! . "<BR><BR>";
					}

	}
	
	}


}

#######

print qq[</span></body></html>];


if ((-e "$data_dir/levels.tmp") > 0) { unlink ("$data_dir/levels.tmp"); }
if ((-e "$data_dir/levels_w.tmp") > 0) { unlink ("$data_dir/levels_w.tmp"); }
if ((-e "$data_dir/ldead.tmp") > 0) { unlink ("$data_dir/ldead.tmp"); }

}



sub delete_dirs
{

if ($q->param('B1') eq "   Yes   ")
	{
	&delete_dead_dirs;
	}
	else
	{

$hbox = acs::get_heading_box("$web_url/ic_erase.gif", "No files and directories deleted.", qq[<p><strong><a href="javascript:onClick=parent.window.close()">Close</a></strong> this window.</p>]);
	
print <<END_OF_RED;
<html>
<head>
<title>PowerSeek</title>
<link href="$web_url/ps.css" rel="stylesheet" type="text/css" /> 
</head>
<body>

$hbox

</body>
</html>
END_OF_RED
	}

}


######################################################


sub webclean
{



$ddata = &get_file_contents("$data_dir/levels_w.tmp");

if ($ddata eq "") ### GET FIRST LEVEL OF DIRECTORIES
	{
	@dcontents = &get_dir_contents($web_dir);
	
	$dirs_checked = "";
	open (CURRL, "> $data_dir/levels_w.tmp");
	open (ALLD, ">> $data_dir/levels.tmp");
		foreach $item (@dcontents)
			{
			if (($item ne "$web_dir/pop") and ($item ne "$web_dir/new") and ($item ne "$web_dir/templates") and ($item ne "$web_dir/edt") and ($item ne "$web_dir/imagefiles"))
				{
				print CURRL "$item\n";
				$item =~ s/$web_dir//gi;
				print ALLD "$item\n";
				$dirs_checked = $dirs_checked . $item . "<BR>";
				}
			}
	close (CURRL);
	close (ALLD);
	}
	else ### GET OTHER LEVELS
	{
	@dirs_to_chck = split (/\n/, $ddata);
	
	open (CURRL, "> $data_dir/levels_w.tmp"); 
	open (ALLD, ">> $data_dir/levels.tmp");
	foreach $item (@dirs_to_chck)
		{
		@dcontents = &get_dir_contents($item);

			foreach $ditem (@dcontents)
				{
					print CURRL "$ditem\n";
					$ditem =~ s/$web_dir//gi;
					print ALLD "$ditem\n";
					$dirs_checked = $dirs_checked . $ditem . "<BR>";				
				}
		}
	close (CURRL);
	close (ALLD);
	}


if ($dirs_checked ne "")
{

$randomnumber = rand(1000); 

$hbox = acs::get_heading_box("$web_url/ic_erase.gif", "Checking for Dead Categories/Directories...", qq[<p><img src="$web_url/working.gif" width="270" height="36">
<table border="0" cellpadding="6" cellspacing="0" width="100%">
  <tr>
    <td width="100%">
    <p>
    <b>Compiled:</b><br>
	 $dirs_checked
	 </p>
    </td>
  </tr>
</table>
</p>
]);


print <<END_OF_REFR;

<html>
<head>
<title>PowerSeek</title>
<meta HTTP-EQUIV="REFRESH" CONTENT="3;URL=$admin_url/clean.cgi?fct=webclean&rnd=$randomnumber">
<link href="$web_url/ps.css" rel="stylesheet" type="text/css" /> 
</head>
<body>
$hbox
</body>
</html>

END_OF_REFR
}
else
{

$hbox = acs::get_heading_box("$web_url/ic_erase.gif", "Category/Directory Map Compiled...", qq[<p><img src="$web_url/working.gif" width="270" height="36">
<table border="0" cellpadding="6" cellspacing="0" width="100%">
  <tr>
    <td width="100%">
    <p>
    Please Wait...
	 </p>
    </td>
  </tr>
</table>
</p>
]);


print <<END_OFNN;
<html>
<head>
<title>PowerSeek</title>
<meta HTTP-EQUIV="REFRESH" CONTENT="3;URL=$admin_url/clean.cgi?fct=dirmapbuilt">
<link href="$web_url/ps.css" rel="stylesheet" type="text/css" /> 
</head>
<body>
$hbox
</body>
</html>
END_OFNN

}

}





sub dirmapbuilt
{

$seekpos = $q->param('seekpos');
if ($seekpos eq "") { $seekpos = 0; }

$dcount = 0;
$sendstring = "";

open (LVS, "$data_dir/levels.tmp");
	seek (LVS, $seekpos, 0);
	while ((defined($line=<LVS>)) and ($dcount < $dirs_to_check))
		{
		$sendstring = $sendstring  . "$line" . "\t";
		$checked_ds = $checked_ds . "$line<BR>";
		$dcount++;
		
		#print "$line";
		}
	$now_pos = tell(LVS);
close (LVS);

### DO QUERY
if ($sendstring ne "")
{
&checkdirs($sendstring);
}


if ($sendstring ne "")
{


$hbox = acs::get_heading_box("$web_url/ic_erase.gif", "Checking... ", qq[<p><img src="$web_url/working.gif" width="270" height="36">
<table border="0" cellpadding="6" cellspacing="0" width="100%">
  <tr>
    <td width="100%">
    <p>
    <b>Checked:</b><br>
	 $checked_ds
	 </p>
    </td>
  </tr>
</table>
</p>
]);


print <<END_OF_REFR;

<html>
<head>
<title>PowerSeek</title>
<meta HTTP-EQUIV="REFRESH" CONTENT="3;URL=$admin_url/clean.cgi?fct=dirmapbuilt&seekpos=$now_pos">
<link href="$web_url/ps.css" rel="stylesheet" type="text/css" /> 
</head>
<body>
$hbox
</body>
</html>

END_OF_REFR

}
else
{

$ddata = &get_file_contents("$data_dir/ldead.tmp"); 

if ($ddata ne "")
{

@dirs = split (/\n/, $ddata);

foreach $item (@dirs)
	{
	$alldirs = $alldirs . "$web_dir/$item<BR>";
	}


$hbox = acs::get_heading_box("$web_url/ic_erase.gif", "Checking... ", qq[
<table border="0" cellpadding="6" cellspacing="0" width="100%">
  <tr>
    <td width="100%">

<p><strong>Clean-Up-Check Complete. </strong></p>
<p>The following directories is not in use anymore: </p>
<p>$alldirs</p>
<p><strong>Would you like to delete these directories with thier contents? </strong></p>
<form method="POST" action="$admin_url/clean.cgi">
  <input type="hidden" name="fct" value="delete_dirs"><p><input type="submit"
  value="   Yes   " name="B1"> <input type="submit" value="    No    " name="B2"> </p>
</form>

    </td>
  </tr>
</table>
]);



print <<END_OF_DEL;

<html>
<head>
<title>PowerSeek SQL</title>
<link href="$web_url/ps.css" rel="stylesheet" type="text/css" /> 
</head>
<body>
$hbox
</body>
</html>

END_OF_DEL

	
}
else
{


$hbox = acs::get_heading_box("$web_url/ic_erase.gif", "Checking... ", qq[<p><strong>Clean-Up Complete.</strong></p>
<p>All the directories previously generated matches up with
what is in your database. There are no unused directories in your 'html' directory.</p>
<p>Your 'html' directory is situated here:<br>
<strong>$web_dir</strong><br>
</p>
]);

print <<END_OF_COMPLETE;

<html>
<head>
<title>PowerSeek SQL</title>
<link href="$web_url/ps.css" rel="stylesheet" type="text/css" /> 
</head>
<body>
$hbox
</body>
</html>

END_OF_COMPLETE

}




}



}





sub checkdirs
{
my ($checkstring) = @_;

### CONSTRUCT SQL

@dirs_to_check = split (/\t/, $checkstring);


$sql = "";
$dirnumber = 0;
foreach $dir_check (@dirs_to_check)
{
$dir_check = substr($dir_check, 1, length($dir_check) - 1);
#print "==> $dir_check <BR>";

$dir_check =~ s/\n//g;

if ($dir_check eq "new") { $dir_check = ""; }
if ($dir_check eq "pop") { $dir_check = ""; }

if ($dir_check eq "templates") { $dir_check = ""; }
if ($dir_check =~ /^templates\//) { $dir_check = ""; }

if ($dir_check eq "edt") { $dir_check = ""; }
if ($dir_check =~ /^edt\//) { $dir_check = ""; }

if ($dir_check eq "imagefiles") { $dir_check = ""; }
if ($dir_check =~ /^imagefiles\//) { $dir_check = ""; }




if ($dir_check ne "")
{

	@idirs = split (/\//, $dir_check);
	$reallevel = @idirs;
	
	$lvc = 1;
	$wsql = "";
	foreach $diritem (@idirs)
		{
		$diritem = acs::decode_dir($diritem);
		$diritem =~ s/'/\\'/g; 
		$wsql = $wsql . " (l"  . $lvc . "= '$diritem') AND";
		$lvc++;  
		}
	#$wsql = substr($wsql, 0, length($wsql) - 3);
	
	$wsql = $wsql . " (level = '$reallevel')";
	
	$sql = $sql . " ($wsql) OR";
	
$dirnumber++;
}	

}

$sql = substr($sql, 0, $sql - 2);

##print "==!!!> $dirnumber<BR>";

##### CHECK IF DIRS EXIST

if ($mysql_hostname eq ""){$dsn = "DBI:mysql:$db_name";}else{$dsn = "DBI:mysql:$db_name:$mysql_hostname:$mysql_port";}
$dbh = DBI->connect($dsn, $db_username, $db_password);
if ( !defined $dbh ) {die "Cannot connect to MySQL server: $DBI::errstr\n"; } 

$sql = "SELECT l1,l2,l3,l4,l5,l6,l7,l8,l9,l10,l11,l12,l13,l14,l15,l16 FROM dirs WHERE $sql";
$sth = $dbh->prepare($sql);


$sth->execute;
#$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror";}
$rows = $sth->rows();


#if ($rows ne $dirnumber)
#{
while ( @row = $sth->fetchrow() )
	{
	$current_cat = "";
	for ($ms = 0; $ms < 16; $ms++) 
		{
			if ($row[$ms] ne "")
			{
			$ecat = acs::encode_dir($row[$ms]);
			$current_cat = $current_cat . "/$ecat";
			}
		}

	$current_cat = substr($current_cat, 1, length($current_cat) -1);
	
	$icntt = 0;
	foreach $di_item (@dirs_to_check)
		{
		$di_item =~ s/\n//g;
		
		
		##print "==> $current_cat <BR>";
		
		if ($di_item eq $current_cat)
			{
			$dirs_to_check[$icntt] = "";
			}
		$icntt++;
		}
	
	}

### WRITE DEAD DIRS
open (DEADD, ">> $data_dir/ldead.tmp");
	foreach $deaditem (@dirs_to_check)
		{
		if ($deaditem ne "")
			{
			print DEADD $deaditem . "\n";
			}
		}
close (DEADD);

#}

$sth->finish;
$dbh->disconnect;


}




sub get_total_dirs
{
my ($dtdir) = @_;
my (@dirlist, @subdirs, $thing, $tmp, $adir, $alldnr, @dsubdirs);

$dirlist[0] = $dtdir;

foreach $adir (@dirlist)
	{
	@subdirs = &get_dir_contents ($adir);
	$tmp = push(@dirlist, @subdirs);
	}


#foreach $itt(@dirlist)
#	{
#	print "==!!!!> $itt\n$dtdir\n\n";
#	}


$alldnr = push(@dirlist);

foreach $adir (@dirlist)
	{
	$alldnr = $alldnr - 1;
	$dsubdirs[$alldnr] = $adir;
	}

#foreach $itt(@dsubdirs)
#	{
#	print "==!!!!> $itt\n$dtdir\n\n";
#	}
#	exit;

return (@dsubdirs);

}
 


sub get_dir_contents
{

my ($dirname) = @_;
my ($cntr,@files,$item5,@subdirs1,$isdir);

$cntr = 0;
opendir(DIR,"$dirname");
	@files = readdir(DIR);
		foreach $item5 (@files)
			{
			$isdir = (-d "$dirname/$item5");
			
			if (($isdir == 1) and ($item5 ne ".") and ($item5 ne ".."))
				{
				$subdirs1[$cntr] = "$dirname/$item5";
				$cntr++;
				}
			}
closedir (DIR);

return (@subdirs1);

} 





sub web_build
{

if ((-e "$data_dir/levels.tmp") > 0) { unlink ("$data_dir/levels.tmp"); }
if ((-e "$data_dir/levels_w.tmp") > 0) { unlink ("$data_dir/levels_w.tmp"); }
if ((-e "$data_dir/ldead.tmp") > 0) { unlink ("$data_dir/ldead.tmp"); }



print <<END_OF_WB;
<html>
<head>
<title>PowerSeek</title>
</head>
<frameset framespacing="0" border="false" rows="108,*" frameborder="0">
  <frame name="header" scrolling="no" noresize target="main" src="$admin_url/clean.cgi?fct=get_top">
  <frame name="main" src="$admin_url/clean.cgi?fct=webclean">
  <noframes>
  <body>
  <p>This page uses frames, but your browser doesn't support them.</p>
  </body>
  </noframes>
</frameset>
</html>
END_OF_WB
}





sub get_top
{

$time = time();
$date = acs::decode_date($time);

open (TBUILD, "> $data_dir/lastcln.dat")  or die "Cannot open $data_dir/lastcln.dat : $!";
	print TBUILD $date;
close (TBUILD);

chmod($default_permissions,"$data_dir/lastcln.dat");
				 
print <<END_OF_TP;

<html>
<head>
<title>PowerSeek</title>
</head>
<body>
<table border="0" cellpadding="0" cellspacing="0" width="100%">
  <tr>
    <td width="100%" bgcolor="#0000A0"><img src="$web_url/logo5.jpg"></td>
  </tr>
</table>
<table border="0" cellpadding="0" cellspacing="0" width="100%" background="$web_url/shadow.gif">
  <tr><td width="1%" bgcolor="#FFFFFF"><font color="#FFFFFF">_</font></td><td width="99%"></td></tr>
</table>


</body>
</html>

END_OF_TP

&image_files_not_in_use;

}







sub get_setup
{

$exists = (-e "$config_cgi");
if ($exists > 0)
	{
	open (STP, "$config_cgi");
		while (defined($line=<STP>))
			{
			if ($line =~ m/#/g)
				{
				$r = pos($line);
				$line = substr($line, 0, $r - 1);
				}
				
				$line =~ s/\n//g;
	
if ($line =~ /^DB_NAME/){$db_name = &get_setup_line($line, DB_NAME);}
if ($line =~ /^DB_USERNAME/){$db_username = &get_setup_line($line, DB_USERNAME);}
if ($line =~ /^DB_PASSWORD/){$db_password = &get_setup_line($line, DB_PASSWORD);}
if ($line =~ /^MYSQL_HOSTNAME/){$mysql_hostname = &get_setup_line($line, MYSQL_HOSTNAME);}
if ($line =~ /^MYSQL_PORT/){$mysql_port = &get_setup_line($line, MYSQL_PORT);}

if ($line =~ /^SCRIPT_URL/){$script_url = &get_setup_line($line, SCRIPT_URL);}
if ($line =~ /^ADMIN_URL/){$admin_url = &get_setup_line($line, ADMIN_URL);}
if ($line =~ /^WEB_URL/){$web_url = &get_setup_line($line, WEB_URL);}
if ($line =~ /^WEB_DIR/){$web_dir = &get_setup_line($line, WEB_DIR);}
if ($line =~ /^DATA_DIR/){$data_dir = &get_setup_line($line, DATA_DIR);}

if ($line =~ /^USERNAME/){$username = &get_setup_line($line, USERNAME);}
if ($line =~ /^PASSWORD/){$password = &get_setup_line($line, PASSWORD);}


			}
	close (STP);
	
	}
}




sub get_setup_line
{
my ($setup_line, $setup_var) = @_;
$crit = "\"";
$setup_line =~ m/$crit/g;
$r1 = pos($setup_line);
$setup_line =~ m/$crit/g;
$r2 = pos($setup_line);
$setup_line = substr($setup_line, $r1, ($r2 - $r1 - 1));
$return_val = $setup_line;
return ($return_val);
}

#### END CONFIGURATION ########################################################

